function [out] = ekvaltab(in)
%vypocte ekvalizacni tabulku ze vstupniho histogramu, napr.:
%
%>> etab=ekvaltab(histogram);
%
%histogram a kumulativni histogram se ziska z obrazku napr. takto:
%
%>> histogram = hist(image(:), pocet_urovni_jasu);
%>> kumhist = cumsum(histogram);
%
%ekvalizovany obrazek 'image_eq' se pak z puvodniho 'image' ziska napr. takto:
%
%>> image_eq = etab(image+1);
%
%jednicka se musi pricist, protoze Matlab indexuje matice od 1, ne od 0.

urovni = max(in(:))+1;
celkem = sum(in);

cin = cumsum(in);
out = round((cin - in/2) / celkem * urovni);
