function [out] = prah(in, prah, max_jas)
%oprahuje jas obrazku zadanou prahovou hodnotou - neni-li druhy argument, pouzije se
%polovina maximalniho jasu, ktery se v obrazku vyskytuje
%pro pixely jejichz jas < prah je jas upraven na 0, pro pixely s jasem >= prah na max.
%
%>> image_prah = prah(image, prah, max_jas);

if nargin <= 2
   max_jas = max(in(:));
end
if nargin == 1
   prah = max_jas/2+1;
end

out = (in >= prah).*max_jas;