% this script demonstrates removal of horizontal motion blur. 

IM=double(imread('zkusebni.tif'));

figure(1);imshow(IM,[]); title('The original image');
figure(2);imshowl(abs(fftshift(fft2(IM))).^2); 
title(['Original image  power spectrum'])

for i=1:4
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  % simulate horizontal motion blurring 
  blur=ones(1,1+2*i)/(1+2*i);
  IMb=conv2(IM,blur,'same'); % blurring the image
  figure(3);imshow(IMb,[]); 
  title(['Horizontal motion blur ',num2str(1+2*i),' pixels wide']);
  figure(4);imshowl(abs(fftshift(fft2(IMb))).^2); 
  title('Power spectrum of the blured image')


  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  % filter the image in order to remove the blur
  [I,J]=size(IM);

  blurmtrx=zeros(I,J);  
  blurmtrx(1,1:i+1)=blur(i+1:end); 
  blurmtrx(1,end-i+1:end)=blur(1:i);
  fftblur=fft2(blurmtrx); % FT of the blurring mask
  cnst=1e-5;
  % compute filter that removes blur: 
  invfilter=conj(fftblur)./(abs(fftblur).^2 + cnst);
  % compute the de-blurred image
  IMdeblur=abs(ifft2(fft2(IMb).*invfilter));
  figure(5); imshow(IMdeblur,[]); title('Image with removed blur');
  figure(6);imshowl(abs(fftshift(fft2(IMdeblur))).^2); 
  title(['Power spectrum of the deblurred image'])

  if i==1
  % arrange windows a little bit 
  for j=0:2
    for k=0:1
      fignum=j*2+k+1;
      pos=get(fignum,'position');
      set(fignum,'position',[j*300 k*200, pos(3:4)])
    end
  end
  end
  
  
  
  disp('Strike a key: ');
  pause  
end




