function [A,im]=affwarp(im1,im2,c1,c2)
% c1 and c2 are corresponding points in images 
% im1 and im2. 
% this function computes the affine transformation A 
% from correspondences and warps image im2 according 
% to this affine transformation, so that the resulting 
% image should look as im1.

N=size(c1,2);

L=[c1(1,:)'   c1(2,:)'   ones(N,1)  zeros(N,1) zeros(N,1) zeros(N,1)
   zeros(N,1) zeros(N,1) zeros(N,1) c1(1,:)'   c1(2,:)'   ones(N,1)];
R=[c2(1,:)'; c2(2,:)'];

a=mldivide(L,R)';
A=zeros(2,3);
A(1,:)=a(1:3);
A(2,:)=a(4:6);

m=size(im1,1);
n=size(im1,2);

im=zeros(m,n);
[x1,y1]=meshgrid(1:n,1:m);

XY2=A*[x1(:)';y1(:)';ones(1,m*n)];
x2=reshape(XY2(1,:),[m n]);
y2=reshape(XY2(2,:),[m n]);

imred    =interp2(double(im2(:,:,1)),x2,y2,'lin');
imgreen  =interp2(double(im2(:,:,2)),x2,y2,'lin');
imblue   =interp2(double(im2(:,:,3)),x2,y2,'lin');

im=zeros([m n 3]);
im(:,:,1)=imred;
im(:,:,2)=imgreen;
im(:,:,3)=imblue;
im=uint8(im/max(im(:))*256);







